﻿Public Class Form1
    'Declaramos una instancia del contexto LINQ To SQL
    Dim dataContext As New LinqToSQLDataContextDataContext

    Sub MostrarGrid()
        'genera una consulta LINQ to SQL utilizando el contexto
        'que se creo con el modelo de clases relacionadas con la base de datos
        'c en este caso es la vinculaciòn al contexto creado
        'y desde ahi podemos realizar la consulta respectiva con SELECT
        'y cargarle los datos en la variable Consulta
        Dim Consulta = From c In dataContext.tbProveedores _
                    Select c.IdProveedor, c.Nombre, c.Apellidos, c.Direccion, c.Telefono, c.tbPaises.NombrePais _
                    Order By IdProveedor

        'para que se generen automàticamente las columnas en el datagridview1
        DataGridView1.AutoGenerateColumns = False
        'Limpia todas las columnas del datagridview1
        DataGridView1.Columns.Clear()

        'genera las columnas del datagridview1 y asi configurar que aparezcan los campos
        'de columnas donde queremos que aparezcan
        'DataGridView1.Columns.Add(nombreColumna, TextoEncabezado)
        DataGridView1.Columns.Add("ID Proveedor", "IdProveedor")
        DataGridView1.Columns.Add("Nombre", "Nombre")
        DataGridView1.Columns.Add("Apellidos", "Apellidos")
        DataGridView1.Columns.Add("Direccion", "Direccion")
        DataGridView1.Columns.Add("Telefono", "Telefono")
        DataGridView1.Columns.Add("NombrePais", "Nombre Pais")

        'Nombre de la propiedad de cada columna
        DataGridView1.Columns(0).DataPropertyName = "IdProveedor"
        DataGridView1.Columns(1).DataPropertyName = "Nombre"
        DataGridView1.Columns(2).DataPropertyName = "Apellidos"
        DataGridView1.Columns(3).DataPropertyName = "Direccion"
        DataGridView1.Columns(4).DataPropertyName = "Telefono"
        DataGridView1.Columns(5).DataPropertyName = "NombrePais"
        'carga el datagridview1 con los datos de la consulta LINQ
        DataGridView1.DataSource = Consulta
    End Sub
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Cargamos los productos que tiene el inventario
        Dim datos = From p In dataContext.tbPaises Select p.IdPais, p.NombrePais
        Me.cmbPaises.DataSource = datos
        ' Indicamos el valor a mostrar
        Me.cmbPaises.DisplayMember = "NombrePais"
        ' Indicamos el codigo asociado al valor mostrado
        Me.cmbPaises.ValueMember = "IdPais"
        MostrarGrid()
        ActualizarDatosGrid()
    End Sub

    Sub LimpiarCajasdeTexto()
        Dim cad$ = txtIdProveedor.Text
        For Each miObjeto As Object In Form1.ActiveForm.Controls
            'Valido si miObjeto es de tipo TextBox.  Si es asi
            'entonces lo dejo en blanco.
            If TypeOf miObjeto Is TextBox Then
                miObjeto.Text = ""
            End If
        Next
        'almacena en txtIdProveedor el código que limpió el procedimiento
        txtIdProveedor.Text = cad
        'Le da el foco al objeto txtNombre
        txtNombre.Focus()
    End Sub

    Sub InhabilitarBotones()
        btnGuardar.Enabled = False
        btnEliminar.Enabled = False
        btnModificar.Enabled = False

    End Sub
    Sub NuevoRegistro()
        btnGuardar.Enabled = True
        btnEliminar.Enabled = False
        btnModificar.Enabled = False

    End Sub
    Sub RegistroExistente()
        btnGuardar.Enabled = False
        btnEliminar.Enabled = True
        btnModificar.Enabled = True
    End Sub
    Private Sub btnBuscar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBuscar.Click
        Try
            'Realiza una consulta utilizando sentencias de LINQ To SQL
            Dim BuscaProveedor = (From prov In dataContext.tbProveedores _
                                          Where prov.IdProveedor = CInt(txtIdProveedor.Text)).ToList()(0)
            'Carga los TextBox respectivos en caso de que haya una vinculacion objetos del modelo
            'con datos de la base de datos con la que se vincula
            txtNombre.Text = BuscaProveedor.Nombre
            txtApellidos.Text = BuscaProveedor.Apellidos
            txtDireccion.Text = BuscaProveedor.Direccion
            txtTelefono.Text = BuscaProveedor.Telefono
            cmbPaises.SelectedValue = BuscaProveedor.IdPais
            'Llama al procedimiento RegistroExistente para que se pueda modificar o eliminar el registro
            RegistroExistente()
        Catch ex As Exception
            'En caso de que no retorne ningun resultado es que no hay datos que
            'concuerden con la búsqueda
            MsgBox("Registro No Existe!", MsgBoxStyle.Information + MsgBoxStyle.OkOnly, "Búsqueda de Registro")
            'Limpia los TextBox del formulario
            LimpiarCajasdeTexto()
            'Como no hya datos se puede agregar como nuevo
            NuevoRegistro()
        End Try
    End Sub


    Private Sub btnGuardar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGuardar.Click
        Dim Proveedor = New tbProveedores
        Proveedor.IdProveedor = txtIdProveedor.Text
        Proveedor.Nombre = txtNombre.Text
        Proveedor.Apellidos = txtApellidos.Text
        Proveedor.Direccion = txtDireccion.Text
        Proveedor.Telefono = txtTelefono.Text
        Proveedor.IdPais = cmbPaises.SelectedValue
        dataContext.tbProveedores.InsertOnSubmit(Proveedor)
        dataContext.SubmitChanges()
        InhabilitarBotones()
        LimpiarCajasdeTexto()
        MostrarGrid()
    End Sub

    Private Sub btnEliminar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEliminar.Click
        Dim eliminaProveedor = (From c In dataContext.tbProveedores _
                              Where c.IdProveedor = CInt(txtIdProveedor.Text)).ToList()(0)
        dataContext.tbProveedores.DeleteOnSubmit(eliminaProveedor)
        'Permite que se hagan los cambios en el contexto de conexion
        dataContext.SubmitChanges()
        InhabilitarBotones()
        LimpiarCajasdeTexto()
        MostrarGrid()
    End Sub

    Private Sub btnModificar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnModificar.Click
        Dim actualizaProveedor = (From c In dataContext.tbProveedores _
                                Where c.IdProveedor = CInt(txtIdProveedor.Text) _
                                Select c).Single
        actualizaProveedor.Nombre = txtNombre.Text
        actualizaProveedor.Apellidos = txtApellidos.Text
        actualizaProveedor.Direccion = txtDireccion.Text
        actualizaProveedor.Telefono = txtTelefono.Text
        actualizaProveedor.IdPais = cmbPaises.SelectedValue
        dataContext.SubmitChanges()
        InhabilitarBotones()
        LimpiarCajasdeTexto()
        MostrarGrid()
    End Sub

    Private Sub btnCerrar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCerrar.Click
        End
    End Sub

    Sub ActualizarDatosGrid()
        Try
            ' ''Obtenemos la fila actual cuyo registro está habilitado
            ''Dim x = Convert.ToInt32(DataGridView1.CurrentCell.RowIndex.ToString())
            ' ''Cargamos en cada TextBox los valores de cada columna, dada por 
            ' ''la posicion del registro (fila x)
            ''txtIdProveedor.Text = DataGridView1("ID Proveedor", x).Value
            ''txtNombre.Text = DataGridView1("Nombre", x).Value
            ''txtApellidos.Text = DataGridView1("Apellidos", x).Value
            ''txtDireccion.Text = DataGridView1("Direccion", x).Value
            ''txtTelefono.Text = DataGridView1("Telefono", x).Value
            ''cmbPaises.Text = DataGridView1("NombrePais", x).Value
            ' ''Ejecuta procedimiento para poder modificar/eliminar el registro
            ' ''por que éste existe y no puede ser ingresado de nuevo.
            ''RegistroExistente()
        Catch ex As Exception

        End Try
    End Sub

    Private Sub DataGridView1_CurrentCellChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles DataGridView1.CurrentCellChanged
        ActualizarDatosGrid()
    End Sub

    Private Sub btnCancelar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        InhabilitarBotones()
        MostrarGrid()
    End Sub

    Private Sub DataGridView1_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles DataGridView1.LostFocus
        InhabilitarBotones()
        txtDireccion.Focus()
    End Sub
End Class
